#include <check.h>
#include <stdio.h>
#include <libgen.h>

#include "ttail_check.h"
#include "ttail.h"
#include "ttail_init.h"
#include "ttail_search.h"

START_TEST (sample0)
{
	int ret;

	ttail->flag |= TTAIL_FLAG_DATE_MIN;
	ttail->date_min.tm_sec = 39;
	ttail->date_min.tm_min = 1;
	ttail->date_min.tm_hour = 0;
	ttail->date_min.tm_mday = 6;
	ttail->date_min.tm_mon = 2;
	ttail_set_fmt(ttail, "%B%n%d %H:%M:%S");
	send_sample_stdpipe(0);
	close_stdpipe();
	ret = ttail_search_std_init(ttail);
	ck_assert_int_eq(ret, 0);
	ret = _ttail_search_closest_stdin(ttail);
	ck_assert_int_eq(ret, 0);
	ck_assert_str_eq(ttail_std_getline_buff(ttail),
	"Mar  6 00:01:39 pilgrim dhclient: DHCPREQUEST on eth0 to \
192.168.0.1 port 67\n");
}
END_TEST

START_TEST (sample0_1)
{
	int ret;

	send_sample_stdpipe(0);
	close_stdpipe();

	ttail->flag |= TTAIL_FLAG_DATE_MIN;
	ttail->flag |= TTAIL_FLAG_PERMISSIVE;
	ttail->date_min.tm_sec = 50;
	ttail->date_min.tm_min = 1;
	ttail->date_min.tm_hour = 0;
	ttail->date_min.tm_mday = 6;
	ttail->date_min.tm_mon = 2;
	ttail_set_fmt(ttail, "%B%n%d %H:%M:%S");
	ret = ttail_search_std_init(ttail);
	ck_assert_int_eq(ret, 0);
	ret = _ttail_search_closest_stdin(ttail);
	ck_assert_int_eq(ret, 0);
	ck_assert_str_eq(ttail_std_getline_buff(ttail),
	"Mar  6 00:29:53 pilgrim dhclient: DHCPREQUEST on eth0 to \
192.168.0.1 port 67\n");
}
END_TEST

TTAIL_CHECK_START(	"ttail search stdin checks",\
			"_ttail_search_closest_stdin() checks")
	TTAIL_SET_FIXTURE(setup_closest_stdin, teardown_closest_stdin);
	TTAIL_ADD_TEST(sample0);
	TTAIL_ADD_TEST(sample0_1);
TTAIL_CHECK_END

