#include <check.h>
#include <stdio.h>
#include <libgen.h>

#include "ttail_check.h"
#include "ttail.h"
#include "ttail_init.h"
#include "ttail_search.h"

START_TEST (sample0)
{
	int ret;
	send_sample_stdpipe(0);
	close_stdpipe();
	ret = ttail_search_std_init(ttail);
	ck_assert_int_eq(ret, 0);
	ck_assert(ttail->session != NULL);
	ck_assert(ttail->flag & TTAIL_FLAG_FORMAT);
	ck_assert_str_eq(ttail->fmt, "%B%n%d %H:%M:%S");
}
END_TEST

START_TEST (empty)
{
	int ret;
	close_stdpipe();
	ret = ttail_search_std_init(ttail);
	ck_assert_int_eq(ret, -1);
}
END_TEST

TTAIL_CHECK_START(	"ttail search stdin checks",\
			"ttail_search_std_init() checks")
	TTAIL_SET_FIXTURE(setup_closest_stdin, teardown_closest_stdin);
	TTAIL_ADD_TEST(sample0);
	TTAIL_ADD_TEST(empty);
TTAIL_CHECK_END

